#!/usr/bin/python
# -* coding: iso-8859-1 -*-
"""
**********************************************************************
File Name:             TEST_HE910.py
Dev:                    Daniele De Santis
Email:                  desantis@areasx.com
Web:                   http://www.areasx.com

Versione:               0.0
Data:                   11/07/13
Note Hardware:          HE910
Note Software:          Py 2.7.2
**********************************************************************
"""
import GPIO
import time
import sys
import SER

def INIT_GPIO():
  SER.set_speed("115200","8N1")
  GPIO.setIOdir(7,0,1)  #Setup output GPIO7 LED green POWER
  GPIO.setIOdir(2,0,1)  #Setup output GPIO2 Pin 2
  GPIO.setIOdir(3,0,1)  #Setup output GPIO2 Pin 3
  GPIO.setIOdir(4,0,0)  #Setup input GPIO4 Pin 4
  GPIO.setIOdir(5,0,0)  #Setup input GPIO5 Pin 5
  GPIO.setIOdir(8,1,1)  #Setup output GPIO8
  
def PrintDEBUG(txt):
  print txt
  SER.send(txt+"\r\n")

def tb_lineno(tb):
  c = tb.tb_frame.f_code
  if not hasattr(tb.tb_frame.f_code, 'co_lnotab'):
    return tb.tb_lineno
  line = tb.tb_frame.f_code.co_firstlineno
  addr = 0
  for i in range(0, len(tb.tb_frame.f_code.co_lnotab), 2):
    addr = addr + ord(tb.tb_frame.f_code.co_lnotab[i])
    if addr > tb.tb_lasti:
      break
    line = line + ord(tb.tb_frame.f_code.co_lnotab[i+1])
  return line

#MAIN
try:
  INIT_GPIO()
  PrintDEBUG("Test Base Telit HE910")
  while(1):
    if(SER.read().find("AT")!=-1):
      GPIO.setIOvalue(7,1) #LED green POWER ON
      sys.exit(1)
    else:
      GPIO.setIOvalue(7,0)  #LED green POWER OFF
    
    GPIO.setIOvalue(2,1)  #Output Pin 2 attivo
    GPIO.setIOvalue(3,1)  #Output Pin 3 attivo
    
    PrintDEBUG("Stato Input -----------")
    PrintDEBUG("Input Pin 4: %d" % GPIO.getIOvalue(4) )
    PrintDEBUG("Input Pin 5: %d" % GPIO.getIOvalue(5))
    PrintDEBUG("")
    PrintDEBUG("ADC: ------------------")
    mV = GPIO.getADC(1)
    PrintDEBUG("mV = %d  Vin= %.1f" % (mV, (mV * 0.0488)))
    PrintDEBUG("")
    time.sleep(1.0)
    GPIO.setIOvalue(2,0)  #Output Pin 2 disattivo
    GPIO.setIOvalue(3,0)  #Output Pin 3 disattivo
    s=GPIO.setIOvalue(7,1) #LED green POWER ON
    time.sleep(1.0)
    
    
except SystemExit, e:
  sys.exit(e)
except:
  type, value, tb = sys.exc_info()
  PrintDEBUG("============= An Exception occurs ============\r\nError Type: %s\r\nError Value: %s\r\n" % (type,value))
  while tb is not None:
    PrintDEBUG("\tFile \"%s\", line %d, in %s\r\n" % (tb.tb_frame.f_code.co_filename, tb_lineno(tb),tb.tb_frame.f_code.co_name))
    tb = tb.tb_next